﻿//
//
using System;
using System.Collections.Generic;
using System.Text;

using CommonMP.HYSSOP.Interface.HSData;
using CommonMP.HYSSOP.CoreImpl.HSData;
using CommonMP.HYSSOP.CoreImpl.HSTools;

namespace jp.or.jccajsce.KinematicWaveBasin
{
    /// <summary><para>class outline:</para>
    /// <para>ＨＹＭＣＯデフォルト提供モデル共通定義クラス</para>
    /// </summary>
    /// <remarks><para>history:</para>
    /// <para>[CommonMP][ver 1.0.0][2008/10/01][新規作成]</para>
    /// </remarks>
    public class KinematicWaveBasinDefine
    {
        //****************************
        //===== サンプル用定義 ========
        //****************************
        /// <summary>システムデフォルトモデルファクトリID</summary>
        public static readonly HySID KinematicWaveBasinModel_Factory = new HySID("jp.or.jccajsce.KinematicWaveBasin_Factory");
//        /// <summary>モデルプロパティ設定画面用ファクトリクラス（独自画面作成時に必要）</summary>
//        public static HySID PROPERTY_SCREEN_FACTORY_LIB_ID = new HySID("Example.ModelPrptyScrnFactory");

        /// <summary>サンプル河道（KinematicWabe)モデル種別</summary>
        public static readonly HySObjectKind KINEMATIC_WAVE_BASIN_KIND = new HySObjectKind("jp.or.jccajsce.KinematicWaveBasin");
        /// <summary>サンプル河道（KinematicWabe)モデル名称</summary>
        public static readonly HySString KINEMATIC_WAVE_BASIN_NAME = new HySString(Properties.Resources.String_MODEL_NAME);



        //********************************
        //===== モデル個別定義 ========
        //********************************
        // ===============================
        // KinematicWave_Basin_流域
        // ===============================
        /// <summary>降雨強度入力</summary>
        public static readonly HySID IN_PATTERN_RAIN = new HySID("RAINIn");
// *****2015/6/30***TKC*****
        /// <summary>降雨強度入力(ポイント時系列)</summary>
        public static readonly HySID IN_PATTERN_P_RAIN = new HySID("RAINIn.POINT");

        /// <summary>Kinematic Wave法（流域）モデル種別</summary>
        public static readonly HySObjectKind KW_BASIN_KIND = new HySObjectKind("jp.or.jccajsce.KinematicWaveBasin");

        /// <summary>上流端入力</summary>
        public static readonly HySID IN_PATTERN_TOP = new HySID("TopIn");
        /// <summary>支流からの横流入 </summary>
        public static readonly HySID IN_PATTERN_LATERAL = new HySID("Lateral");
        /// <summary>下流端出力</summary>
        public static readonly HySID OUT_PATTERN_BOTTOM = new HySID("BottomOut");
        /// <summary>下流端出力（1次元時系列）</summary>
        public static readonly HySID OUT_PATTERN_BOTTOM_1D = new HySID("BottomOut1D");
        /// <summary>全セル内容出力</summary>
        public static readonly HySID OUT_PATTERN_ALL = new HySID("AllCellOut");
        /// <summary>任意</summary>
        public static readonly HySID IN_OUT_PATTERN_ANY = new HySID("ANY");
        /// <summary>任意</summary>
        public static readonly HySID IN_OUT_PATTERN_ANY_ONE = new HySID("ANY_ONE");


    }
}
