﻿// <summary>ソースコード：ＨＹＭＣＯサンプルモデルファクトリクラス</summary>
// <author>CommonMP</author>

using System;
using System.Collections.Generic;
using System.Text;

using CommonMP.HYSSOP.Interface.HSData;
using CommonMP.HYSSOP.Interface.HSViewer;
using CommonMP.HYSSOP.CoreImpl;
using CommonMP.HYSSOP.CoreImpl.HSData;
using CommonMP.HYSSOP.CoreImpl.HSTools;

using CommonMP.HYMCO.Interface;
using CommonMP.HYMCO.Interface.Model;
using CommonMP.HYMCO.Interface.Data;
using CommonMP.HYMCO.Interface.Controller;

using CommonMP.HYMCO.CoreImpl.Model;
using CommonMP.HYMCO.CoreImpl.Data;

using CommonMP.HYMCO._SYSTEM_;

namespace CommonMP.HYMCO._SYSTEM_
{
    /// <summary><para>class outline:</para>
    /// <para>ＨＹＭＣＯモデルファクトリ生成</para>
    /// </summary>
    /// <remarks><para>history:</para>
    /// <para>[CommonMP][ver 1.0.0][2009/10/01][新規作成]</para>
    /// </remarks>
    public class HYMCO_MODEL_FACTORY_CREATOR_IMPLE : HYMCO_MODEL_FACTORY_CREATOR
    {
        /// <summary><para>method outline:</para>
        /// <para>コンストラクター</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> HYMCO_MODEL_FACTORY_CREATOR_IMPLE csFactCrt = new HYMCO_MODEL_FACTORY_CREATOR_IMPLE( ) </para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>生成インスタンス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public HYMCO_MODEL_FACTORY_CREATOR_IMPLE()
        {
        }
        /// <summary><para>method outline:</para>
        /// <para>演算モデルファクトリクラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McModelFactory csCalModelFactory = CreateFactory( ) </para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>演算モデルファクトリクラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public CommonMP.HYMCO.Interface.Model.McModelFactory CreateFactory()
        {
            return new jp.or.jccajsce.KinematicWaveBasin.KinematicWaveBasinModelFactory();
        }
    }
}

namespace jp.or.jccajsce.KinematicWaveBasin
{
    /// <summary><para>class outline:</para>
    /// <para>サンプルモデルファクトリクラス</para>
    /// </summary>
    /// <remarks><para>history:</para>
    /// <para>[CommonMP][ver 1.0.0][2008/10/01][新規作成]</para>
    /// </remarks>
    public class KinematicWaveBasinModelFactory : McBasicModelFactoryBase
    {
        /// <summary><para>method outline:</para>
        /// <para>デフォルトコンストラクタ</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para>McSampleModelFactory csFactory = new McSampleModelFactory()</para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>インスタンス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public KinematicWaveBasinModelFactory( )
        {
        }

        /// <summary><para>method outline:</para>
        /// <para>ファクトリ識別子を生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> HySID csFactID = CreateFactoryID( ) </para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>ファクトリ識別子</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override HySID CreateFactoryID()
        {
            return KinematicWaveBasinDefine.KinematicWaveBasinModel_Factory;
        }

        /// <summary><para>method outline:</para>
        /// <para>演算モデルクラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McCalModel csCalModel = CreateCalModel(csModelKind) </para>
        /// </example>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>演算モデルクラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McCalModel CreateCalModel(HySObjectKind csModelKind)
        {
            McCalModel csCalModel = null;

            if (csModelKind == KinematicWaveBasinDefine.KINEMATIC_WAVE_BASIN_KIND)
            {
                csCalModel = new McKinematicWaveBasinModel();
            }
          
            return csCalModel;
        }

        /// <summary><para>method outline:</para>
        /// <para>要素内演算中データクラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McCalInfo csCalModel = CreateCalInfo( csModelKind ) </para>
        /// </example>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>要素内演算中データクラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McCalInfo CreateCalInfo(HySObjectKind csModelKind)
        {
            McCalInfo csCalInfoData = null;

            if (csModelKind == KinematicWaveBasinDefine.KINEMATIC_WAVE_BASIN_KIND)
            {
                csCalInfoData = new McKinematicWaveBasinCalInfo();
            }

            return csCalInfoData;
        }

        /// <summary><para>method outline:</para>
        /// <para>モデルプロパティ表示／設定情報クラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McPropertyInfoRoot csPropertyInf = CreateModelPropertyInfo(csLibraryID, csModelKind ) </para>
        /// </example>
        /// <param name="csLibraryID">ライブラリー識別子</param>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>モデルプロパティ表示／設定情報クラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McCellModelPropertyIF CreateModelProperty(HySID csLibraryID, HySObjectKind csModelKind)
        {
            if (this.EqualFactory(csLibraryID) == false)
            {
                return null;
            }

            McCellModelPropertyInfo csRtnCellPrptyDt = null;


            
            
            if (csModelKind == KinematicWaveBasinDefine.KINEMATIC_WAVE_BASIN_KIND)
            {   // 流出解析 KinematicWabe法
                csRtnCellPrptyDt = new McCellModelPropertyInfo(csLibraryID, csModelKind);

                csRtnCellPrptyDt.SetStepTime((double)300); // δT設定
                //csRtnCellPrptyDt.SetStepTime((double)48 * 3600 / 2400); // δT設定

                csRtnCellPrptyDt.AddInfoType("m_lCelNumber", Properties.Resources.String_Slope_Partision, McDefine.ValKind.LONG);       //分割数
                csRtnCellPrptyDt.SetInfo("m_lCelNumber", 10);
                csRtnCellPrptyDt.AddInfoType("m_dSlope", Properties.Resources.String_Slope_Incline, McDefine.ValKind.DOUBLE);           //斜面勾配(-)
                csRtnCellPrptyDt.SetInfo("m_dSlope", 1.0 / 100.0);
                csRtnCellPrptyDt.AddInfoType("m_dLength", Properties.Resources.String_Slope_Length, McDefine.ValKind.DOUBLE);           //斜面長(m)
                csRtnCellPrptyDt.SetInfo("m_dLength", 2500.0);
                csRtnCellPrptyDt.AddInfoType("m_dWidth", Properties.Resources.String_Slope_Width, McDefine.ValKind.DOUBLE);             //斜面幅(m)
                csRtnCellPrptyDt.SetInfo("m_dWidth", 1000.0);
                csRtnCellPrptyDt.AddInfoType("m_dRough", Properties.Resources.String_Equivalent_Roughness, McDefine.ValKind.DOUBLE);    //等価租度(-)
                csRtnCellPrptyDt.SetInfo("m_dRough", 0.03);

                // -----------------------
                //csRtnCellPrptyDt.AddInfoType("m_inLQ", "横流入させる斜面位置(斜面上流からの分割NO）", McDefine.ValKind.LONG);
                //csRtnCellPrptyDt.SetInfo("m_inLQ", 20);
                // -----------------------

                
                
                
                // 受信可能なパターン
                {

                    // ********************
                    // 第Ｘパターン（降雨強度の入力）
                    // 一次元時系列でのインプット
                    McTranInfoPattern csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        KinematicWaveBasinDefine.IN_PATTERN_RAIN,
                        McTranInfoDefine.D1_CELL_SERIAL,
                        Properties.Resources.String_Rain_To_Basin) as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1);
                        {
                            //csCellChara.SetDataKind(0, "雨量", HySDataKindDefine.SCALOR_RAIN_FALL, "mm/H"); // 変数は雨量
                            csCellChara.SetDataKind(0, Properties.Resources.String_Rain, HySDataKindDefine.SCALOR_RAIN_FALL, "mm/hr"); // 変数は雨量
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                        csTrnPtn.SetInterpolateType(HySDefine.InterpolateType.NO_INTERPOLATE); // 内挿方法設定
                        //csTrnPtn.SetInterpolateType(HySDefine.InterpolateType.LINEAR); // 内挿方法設定
                    }
                    csRtnCellPrptyDt.AddReceivePattern(csTrnPtn);    // 受信可能パターンの追加

                    // *****2015/6/30**TKC***
                    // ポイント時系列でのインプット
                    csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        KinematicWaveBasinDefine.IN_PATTERN_P_RAIN,
                        McTranInfoDefine.SINGLE_CELL_SERIAL,
                        Properties.Resources.String_Rain_To_Basin) as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1);
                        {
                            //csCellChara.SetDataKind(0, "雨量", HySDataKindDefine.SCALOR_RAIN_FALL, "mm/H"); // 変数は雨量
                            csCellChara.SetDataKind(0, Properties.Resources.String_Rain, HySDataKindDefine.SCALOR_RAIN_FALL, "mm/hr"); // 変数は雨量
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                        csTrnPtn.SetInterpolateType(HySDefine.InterpolateType.NO_INTERPOLATE); // 内挿方法設定
                        //csTrnPtn.SetInterpolateType(HySDefine.InterpolateType.LINEAR); // 内挿方法設定
                    }
                    csRtnCellPrptyDt.AddReceivePattern(csTrnPtn);    // 受信可能パターンの追加
                    // ********************

/*
                    // 第１パターン
                    McTranInfoPattern csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        McKinematicWaveBasinDefine.IN_PATTERN_TOP,
                        McTranInfoDefine.SINGLE_CELL_SERIAL,
                        "上流端流入") as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1);
                        {
                            csCellChara.SetDataKind(0, "流量", HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/sec"); // 最初の変数は流量
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                        csTrnPtn.SetInterpolateType(HySDefine.InterpolateType.LINEAR); // 内挿方法設定
                    }
                    csRtnCellPrptyDt.AddReceivePattern(csTrnPtn);    // 受信可能パターンの追加
                    // 第２パターン
                    csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        McKinematicWaveBasinDefine.IN_PATTERN_LATERAL,
                        McTranInfoDefine.SINGLE_CELL_SERIAL,
                        "支流からの横流入") as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1);
                        {
                            csCellChara.SetDataKind(0, "流量", HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/sec"); // 最初の変数は流量
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                        csTrnPtn.SetInterpolateType(HySDefine.InterpolateType.LINEAR); // 内挿方法設定
                    }
                    csRtnCellPrptyDt.AddReceivePattern(csTrnPtn);    // 受信可能パターンの追加
*/



                
                }
                
                
                
                
                
                // 送信パターンの設定
                {
                    // 第１パターン
                    McTranInfoPattern csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        KinematicWaveBasinDefine.OUT_PATTERN_BOTTOM,
                        McTranInfoDefine.SINGLE_CELL_SERIAL,
                        Properties.Resources.String_Out_Bottom) as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(3);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.String_QQ, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, Properties.Resources.String_QQ_Unit1);
                            csCellChara.SetDataKind(1, Properties.Resources.String_HH, HySDataKindDefine.WATER_LEVEL, Properties.Resources.String_HH_Unit1);
                            csCellChara.SetDataKind(2, Properties.Resources.String_VV, HySDataKindDefine.SCALOR_VELOCITY, Properties.Resources.String_VV_Unit1);
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                    }
                    csRtnCellPrptyDt.AddSendPattern(csTrnPtn);
                    
                    // 第２パターン
                    csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        KinematicWaveBasinDefine.OUT_PATTERN_ALL,
                        McTranInfoDefine.D1_CELL_SERIAL,
                        Properties.Resources.String_All_of_Cells) as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(3);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.String_QQ, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, Properties.Resources.String_QQ_Unit1);
                            csCellChara.SetDataKind(1, Properties.Resources.String_HH, HySDataKindDefine.WATER_LEVEL, Properties.Resources.String_HH_Unit1);
                            csCellChara.SetDataKind(2, Properties.Resources.String_VV, HySDataKindDefine.SCALOR_VELOCITY, Properties.Resources.String_VV_Unit1);
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                    }
                    csRtnCellPrptyDt.AddSendPattern(csTrnPtn);

                    // 第3パターン
                    csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        KinematicWaveBasinDefine.OUT_PATTERN_BOTTOM_1D,
                        McTranInfoDefine.D1_CELL_SERIAL,
                        Properties.Resources.String_Out_Bottom) as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(3);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.String_QQ, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, Properties.Resources.String_QQ_Unit1);
                            csCellChara.SetDataKind(1, Properties.Resources.String_HH, HySDataKindDefine.WATER_LEVEL, Properties.Resources.String_HH_Unit1);
                            csCellChara.SetDataKind(2, Properties.Resources.String_VV, HySDataKindDefine.SCALOR_VELOCITY, Properties.Resources.String_VV_Unit1);
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                    }
                    csRtnCellPrptyDt.AddSendPattern(csTrnPtn);

                }
            }

            return csRtnCellPrptyDt;
        }

        /// <summary><para>method outline:</para>
        /// <para>モデル初期化表示／設定情報生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McPropertyInfoRoot csInitialInf = CreateModelInitialInfo(csLibraryID, csModelKind ) </para>
        /// </example>
        /// <param name="csLibraryID">ライブラリー識別子</param>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>初期情報クラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McPropertyInfoRoot CreateModelInitialInfo(HySID csLibraryID, HySObjectKind csModelKind)
        {
            if (this.EqualFactory(csLibraryID) == false)
            {
                return null;
            }

            McInitialInfo csRtnDt = null;

            if (csModelKind == KinematicWaveBasinDefine.KINEMATIC_WAVE_BASIN_KIND)
            {
                csRtnDt = new McInitialInfo(csLibraryID, csModelKind);

                csRtnDt.AddInfoType("H_Initial", Properties.Resources.String_Depth_of_the_Water_Initial_Value_in_the_Slope, McDefine.ValKind.DOUBLE);
                csRtnDt.SetInfo("H_Initial", 0.0);
                csRtnDt.AddInfoType("Q_Initial", Properties.Resources.String_Flow_Quantity_Initial_Value_in_the_Slope, McDefine.ValKind.DOUBLE);
                csRtnDt.SetInfo("Q_Initial", 0.0);
                csRtnDt.AddInfoType("V_Initial", Properties.Resources.String_Speed_Initial_Value_in_the_Slope, McDefine.ValKind.DOUBLE);
                csRtnDt.SetInfo("V_Initial", 0.0);
            }
            return csRtnDt;
        }

        /// <summary><para>method outline:</para>
        /// <para>モデル情報提供</para>
        /// </summary>
        /// <example>
        /// <para>usage:</para>
        /// <para>HySDataLinkedList csModelInfoList = GetCalModelInfoList();</para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>モデル情報のリスト</returns>
        /// <exception cref="">無し</exception>
        /// <remarks>
        /// <para>remarks:</para>
        /// <para>モデル情報(McModelInfo)をリスト形式で返却する</para>
        /// </remarks>
        public override HySDataLinkedList GetCalModelInfoList()
        {
            McModelInfo csModelInfo=null;

            csModelInfo = new McModelInfo(
                    (HySID)this.GetFactoryID(),
                    McModelLibraryDefine.DIVISION_CALCULATION_MODEL,
                    new HySObjectKind("CAL_HYDROLOGICAL_MODELS"), // <-- LibraryCategoryXML.xmlに定義されている値を使用す
                    KinematicWaveBasinDefine.KW_BASIN_KIND,
                    KinematicWaveBasinDefine.KINEMATIC_WAVE_BASIN_NAME);
            csModelInfo.SetVersionInf("Ver1.0 ");
            csModelInfo.SetSummaryInf(Properties.Resources.STRING_about);
            csModelInfo.SetCreatorInf(Properties.Resources.String_MODEL_CREATOR);
            csModelInfo.SetIconName("jp.or.jccajsce.KinematicWave");
            csModelInfo.SetManualFileName("jp.or.jccajsce.KinematicWaveBasin.pdf"); // <-- モデル解説書

            m_csCalModelInforList.AddLast(csModelInfo);


            return m_csCalModelInforList;
        }

    }
}
